 //

 
 import net.jini.core.lookup.ServiceRegistrar;
 import net.jini.core.lookup.ServiceID;
 import net.jini.core.discovery.LookupLocator;
 import net.jini.discovery.LookupDiscovery;
 import net.jini.discovery.DiscoveryListener;
 import net.jini.discovery.DiscoveryEvent;
 import java.io.*;
 import java.rmi.*;
 import java.rmi.server.*;
 import java.util.Vector;

//XML - A Distributed Computing Paradigm - Ajay M R
 
 // Lookup Service Find - Does discovery to find the nearby lookup
 // services and print-out the same
 public class LookupServiceFind implements DiscoveryListener {
 	   public static Vector v = new Vector();
 	   
 	   public static synchronized void findAllServices() {
				try {
					      if(System.getSecurityManager() == null)	
                System.setSecurityManager(new RMISecurityManager());
             
             // flush the Vector to store the new lookup locators
                v.removeAllElements();
             
             // Create LookupDiscovery object which will be responsible for informing to the DiscoveryListener object for new lookupservice
             // or discarded service
                LookupDiscovery ld = new LookupDiscovery(LookupDiscovery.NO_GROUPS);
             
             // Instance of LookupServiceFind added as Listener object
             // IF new lookupservice is found the discoverd method will be called
             
                ld.addDiscoveryListener(new LookupServiceFind());
             
             // Create LookupDiscovery with LookupDiscovery.ALL_GROUPS 
             // Halt the process temporarily since we have to attach our Listener object we just temproraly
                ld.setGroups(LookupDiscovery.ALL_GROUPS);
             
             // This sleep time may not be sufficient sometimes when the lookup service
             // if far off, like on internet!, - so any usage of getLocators is not guarenteed one.
             
                Thread.currentThread().sleep(60000L);
         }
         catch (Exception e) {
               System.out.println("LookupServiceFind Exception:" + e);
         }
 	   		
 	   		} 
 	   	
     public static void main (String[] args) {

				findAllServices();
     }

     public void discovered(DiscoveryEvent de) {
  
         try {
             // Invoke getRegistrar() on the LookupLocator to cause it to perform unicast discovery on the lookup service indicated
             // by the host and port number passed to the constructor. 
             // Get the Reference to the registar object sent from the lookup service.
                ServiceRegistrar[] registrars = de.getRegistrars();
						 
	            // A lookup service is, after all, a service - To
	           // get the ID it assigns to itself, call getServicerID() on the registrar object.
	             
             for (int i = 0; i < registrars.length; ++i) {
                 ServiceID id = registrars[i].getServiceID();
                 LookupLocator lookupLocator = registrars[i].getLocator();
                 v.addElement(lookupLocator);
                 String host = lookupLocator.getHost();
                 int port = lookupLocator.getPort();
								 	
                 System.out.println("Lookup Service: jini://" + host + ":"
                     + port + ", " + id.toString());
             }
         } 
         catch (Exception e) {
               System.out.println("LookupServiceFind Exception:" + e);
         }
     }

     public void discarded(DiscoveryEvent de) {
     	
     	// nothing we do here. This can be a point of sudden unavailability of any lookup service
     	// taking some remedy in our application
     }
     
     public static LookupLocator [] getLocators() {
     	// find all services available
     	findAllServices();
     	LookupLocator[] locators = new LookupLocator[v.size()];
     	// copy all elements to Locator Array
     	v.copyInto(locators);
     	// send it across
     	return locators; 
     }
 }
