/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* This is more like a data manager interface, which acts like a database gateway. It allows various processes to interact with the Interface database. Though the interface system would have a low-end database this service would be useful to interact with the databases when they grow big. Further, the data manager has capability ot use files as storage areas. */
public interface DatabaseInterface
{
	/* Sets the minimal parameters to interface with the database. This includes DSN name and authentication details. */
	public abstract boolean SetDatabaseParameters(char DatabaseDSN,
											   char Username,
											   char Password,
											   char FileDatabasePath,
											   double MaxFileDatabaseSize);
	/* Sets the database type. As for initial usage it would be possible to use a simple text file with data in XML format for low install overhead. */
	public abstract boolean SetDatabaseType(char DatabaseType);
	/* Allows the processes to insert data in the database. Accepts the SQL embedded in XML format. The database interface needs to reformat the query for storing the same in file format. */
	public abstract boolean InsertXMLStream(XMLDocumentInstance XMLQueryStream);
	/* Allows the processes to update data in the database. Accepts the SQL embedded in XML format. The database interface needs to reformat the query for storing the same in file format. */
	public abstract boolean UpdateXMLStream(XMLDocumentInstance XMLQueryStream);
	/* Allows the processes to delete data in the database. Accepts the SQL embedded in XML format. The database interface needs to reformat the query for storing the same in file format. */
	public abstract boolean DeleteXMLStream(XMLDocumentInstance XMLQueryStream);
	/* Allows the processes to select the data from the database. Accepts the SQL embedded in XML format. The database interface returns the result set in XML format. */
	public abstract char SelectAsXMLStream(XMLDocumentInstance XMLQueryStream);
	/* Preliminary setting for number of concurrent conenctions to be allowed. This would limit the threads created for attending client connection requests at later stages. */
	public abstract boolean MaxActiveConnections(int NumberOfEconnections);

}
/* END CLASS DEFINITION DatabaseInterface */
