/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* Generic utility class for interpretting and constructing system messages. As our model is porposed to use generic message in XML format, this class would be used  to provide interpreting logic for the same. It would also allow different system to use the methods to construct and arrive at XML message specific to our system. */
public interface GenericXMLMessageInterface
{
	/* Provides validation logic for validating a message packet as required to be processed in our system. */
	public abstract boolean ValidateMessagePacket(XMLDocumentInstance XMLMessagePacket);
	/* Return a string specifying the message type for the passed message XML packet.  */
	public abstract char GetMessageType(XMLDocumentInstance XMLMessagePacket);
	/* Return a string specifying the method name for the passed message XML packet. */
	public abstract char GetMethodName(XMLDocumentInstance XMLMessagePacket);
	/* Return a XML string specifying the message load for the passed message XML packet. */
	public abstract XMLDocumentInstance GetMessageLoad(XMLDocumentInstance XMLMessagePacket);
	/* Sets the message type for the new XML message packet composition. */
	public abstract XMLDocumentInstance SetMessageType(char MessageType);
	/* Sets the message load for the new XML message packet composition. */
	public abstract XMLDocumentInstance SetMessageLoad(XMLDocumentInstance XMLMessageLoad);
	/* Sets the method name for the new XML message packet composition. */
	public abstract XMLDocumentInstance SetMethodName(char MethodName);
	/* Generates and return the complete XML stream representing the message packet contructed from SetXXX methods. */
	public abstract XMLDocumentInstance GenerateMessagePacket(char MessageType,
														   char MethodName,
														   XMLDocumentInstance MessageLoad);

}
/* END CLASS DEFINITION GenericXMLMessageInterface */
