/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* Provides logging services to all system objects. */
public interface LogInterface
{
	/* Sets the log file path. */
	public abstract boolean SetLogFilePath(char LogFilePath,
										char LogFileName);
	/* Appends to the current log as Text message. The entry to be appended is passed to this method as XML stream. */
	public abstract boolean WriteToLogAsText(XMLDocumentInstance LogMessage);
	/* Appends to the current log as HTML message. The entry to be appended is passed to this method as XML stream. */
	public abstract boolean WriteToLogAsHTML(XMLDocumentInstance LogMessage);
	/* Sets the maximum log file size. The system mechanism would try to retireve the current log to secondary path, once the max size is reached. */
	public abstract boolean SetMaxLogFileSize(double LogFileSize);
	/* Alternate log file path to dump or move the existing log file, once it exceeds maximum size. */
	public abstract boolean SetSecondaryLogFilePath(char LogFilePath,
												 char LogFileName);

}
/* END CLASS DEFINITION LogInterface */
