/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* SOAP Communication interface allows SOAP to be used to interact with the query engine. */
public interface SOAPCommunicationInterface
{
	/* Initialize SOAP services, reads the security and configuration parameters and also acts as wrapper on current SOAP services over web. */
	public abstract boolean InitializeSOAPServices();
	/* Set central processor reference. */
	public abstract void SetCentralProcessorReferences();
	/* Process SOAP Request passed as parameter, returns the results in XML SOAP format. */
	public abstract XMLDocumentInstance ProcessRPCRequest(XMLDocumentInstance RPCRequest);
	/* Validate SOAP Request XML stream. */
	public abstract boolean ValidateRPCRequest(XMLDocumentInstance RPCRequestXML);
	/* Converts a SOAP Result set in to RPC Result set, so that we deal with only one type in system. */
	public abstract XMLDocumentInstance SOAPToRPCRequest(XMLDocumentInstance SOAPRequestDocument);
	/* Formats our RPC request into SOAP format. This method requires additional SOAP related attributes to be passed as XML and hence has 2 parameters. */
	public abstract XMLDocumentInstance FormatRPCAsSOAPRequest(XMLDocumentInstance RPCRequest,
															XMLDocumentInstance SOAPParameters);

}
/* END CLASS DEFINITION SOAPCommunicationInterface */
