/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* This interface allows our Interface system to interact with the client ERP FTP node. */
public interface FTPInterface
{
	/* Initializes the FTP services, by providing batch job reference file to start the services and the guidelines to where the actual FTP folder is located. */
	public abstract boolean InitializeFTPServices(char FTPFolderPath,
											   char FTPServerBatch,
											   char FTPUsername,
											   char FTPPassword);
	/* Resets FTP interface services, works as soft-initialization routine. */
	public abstract boolean ResetFTPServices();
	/* Starts the FTP service. On Re-Initialization this method has to be called again. */
	public abstract boolean StartFTPServices();
	/* Stops the FTP services. But the interface is still initialized and could be start with StartFTPServices method. */
	public abstract boolean StopFTPServices();
	/* FTP file count specifying the current number pending to be sent over to client system. */
	public abstract long CurrentJobCounts();
	/* Places the job or FTP file in the FTP folder for processing and returns a number - Token#. This method may process the string and save as file in the FTP folder and create a pending entry in current XML reference stream, assigning the next token. */
	public abstract char GetNextToken(XMLDocumentInstance XMLJobStream);
	/* This method would allow the FTP service to resume using soft-trigger. This would allow for a system to save the entry in the FTP file and ask the interface to use it. */
	public abstract boolean RefreshQueue();
	/* For the various FTP files created, this method call would specify the filename and path to store the processed request for future reference as archived. */
	public abstract boolean SetArchiveFile(char ArchiveFilePath,
										char ArchiveFileName);

}
/* END CLASS DEFINITION FTPInterface */
