/* Static Model */
package sams;


import sams.CentralProcessorInterface;
import sams.ErrorQueueInterface;
import sams.SecurityInterface;
import sams.TrackingInterface;
import sams.XMLDocumentInstance;
/* Gateway Services would be offered to the thrid party systems interacting with the system like ATM stations and Merchant channels. */
public interface GatewayServicesInterface
{
	/* Initializes the gateway component. This would trigger the sub interfaces for ATM and Merhcant channels. Any configuration settings would be read here. */
	public abstract boolean InitializeGatewayServices();
	/* Sets the reference to central processor, used for tieing up with the central processor instance. */
	public abstract boolean SetCentralProcessorReference(CentralProcessorInterface CentralProcessorReference);
	/* Processes the web POST request. The request format would assume the generic message system format. */
	public abstract XMLDocumentInstance ProcessRequestAsPOST(XMLDocumentInstance RequestPacket);
	/* Process request as string packet format. The method reforms the request from flat string into system required XML format. */
	public abstract char ProcessRequestAsString(char RequestPacket);
	/* Sets reference to Tracking object. */
	public abstract boolean SetTrackingReference(TrackingInterface TrackObjectReference);
	public abstract boolean SetSecurityReference(SecurityInterface SecurityObjectReference);
	/* Verify or authenticate merchant information. */
	public abstract boolean VerifyMerchant(XMLDocumentInstance MerchantDetails);
	/* Verify ATM Location request for processing. */
	public abstract boolean VerifyATMLocation(XMLDocumentInstance ATMProcessRequest);
	/* Process the request as unidirectional, so that the request by a third party location can be placed on queue after authentication. Please note that this request would die once submitted and require the request to be in system requried generic message packet format. */
	public abstract boolean ProcessRequestAsUnidirectional(XMLDocumentInstance RequestPacket);
	/* Sets the error queue reference to log errors. */
	public abstract boolean SetErrorQueueReference(ErrorQueueInterface ErrorObjectReference);
	/* Shuts all the services offered by gateway component. This would also kill the initialization routine initiated settings. */
	public abstract boolean ShutdownServices();
	/* Start services would start the component. */
	public abstract boolean StartServices();
	/* Stop services, this does not kill the initialization settings. */
	public abstract boolean StopServices();

}
/* END CLASS DEFINITION GatewayServicesInterface */
