/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* Message Queue is element to provide queuing mechaism to all messages. It has queue access messages and is used to implement both IN and OUT messages. */
public interface MessageQueueInterface
{
	/* Initialize the IN/OUT queue. This operation sets the queue size. This routine would use the configuration file to read this initial settings. */
	public abstract boolean InitializeQueue(char QueueFilePath,
										 char QueueFileName);
	/* Calling this method would result in current the queue written to a disk file. The file format would represent a XML stream with all the current messages in queue.  */
	public abstract boolean PersistQueue(char PersistFilePath,
									  char PersistFileName);
	/* This method would cause the queue to be rebuilt from the persistent store, which is an XML disk file representing error messages on queue. */
	public abstract boolean RefreshQueue(boolean ReadFile,
									  boolean ReadFromPersistFileStore);
	/* Gets the current messages accounted in the queue. */
	public abstract double GetCurrentQueueCount();
	/* Dumps the message in IN queue.  */
	public abstract double PutInINQueue(XMLDocumentInstance ErrorPacket);
	/* Returns IN queue message the as generic XML message packet.  */
	public abstract XMLDocumentInstance GetFromINQueue(double ErrorToken,
													char OperationMethod);
	/* This method would delete the entire error queue. The method requires a authentication key to perform the operation. */
	public abstract boolean DeleteQueue(double SecurityKey);
	/* Dumps the message in OUT queue.  */
	public abstract double PutInOUTQueue(XMLDocumentInstance ErrorPacket);
	/* Returns OUT queue message the as generic XML message packet.  */
	public abstract XMLDocumentInstance GetFromOUTQueue(double ErrorToken,
													 char OperationMethod);

}
/* END CLASS DEFINITION MessageQueueInterface */
