/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* Used to offer rendering services for User Interfaces GUI. This would be used by web services to generate HTML source for offering online services. Rendering services may include complex screen descriptions that must be generalized using scheme's document. This helps in maintaining consistent rendered looks on different formats. */
public interface RenderingInterface
{
	/* Register the rendering style scheme described as XML stream. Each of this streams would be then referenced and used by the rendering engine. Returns registration token that has to be used for future referencing to use rendering services. */
	public abstract double RegisterRenderStyleXMLScheme(XMLDocumentInstance RenderScheme);
	/* Renders the referenced message apcket in HTML format using specified scheme, the scheme parameter may be blank. */
	public abstract boolean RenderAsHTML(XMLDocumentInstance XMLMessagePacket,
									  char XMLScheme);
	/* Renders the referenced message apcket in RTF [Rich Text Format] format using specified scheme, the scheme parameter may be blank. */
	public abstract boolean RenderAsRTF(XMLDocumentInstance XMLMessagePacket,
									 char XMLScheme);
	/* Renders the referenced message apcket in CSV [Comma Seperated Values] format using specified scheme, the scheme parameter may be blank. */
	public abstract boolean RenderAsCSV(XMLDocumentInstance XMLMessagePacket,
									 char XMLScheme);

}
/* END CLASS DEFINITION RenderingInterface */
