/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* Tracks the various processed messages in to specfied database. It has ability to set the track level so as to identify the details to be captured in the track record. Please note that the default attributes of a track record are Date and Time, at minimum. */
public interface TrackingInterface
{
	/* Sets the parameters for pointing to the track database */
	public abstract int SetTrackDatabase(char DSN,
									  char Username,
									  char Password);
	/* Initialize the tracking services */
	public abstract boolean InitializeTrackker();
	/* Append track record. Same as save track record to the tracking database. */
	public abstract int AppendTrackRecord(XMLDocumentInstance TrackRecord);
	/* Query the tracking database to get the track details for a specified date range. */
	public abstract XMLDocumentInstance GetTrackingDetails(char FromDate,
														char ToDate);
	/* Track level specifies the amount of details to be captured from the message packet. Usually 3 drill down levels are fine. Level 1 will save all the details, 2 will save only the message header with primary load and 3 would store only header. */
	public abstract void SetTrackLevel();

}
/* END CLASS DEFINITION TrackingInterface */
