/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* XML Database container. This obejct allows the simplistic database operations to be done in XML way. The system would use this object to create memory image of XML document, which can be used as database. This model uses the advantage of applying XQuery for querying the model. */
public interface XMLDataManager
{
	/* Initialize XML database container. */
	public abstract boolean InitializeXMLDataManager();
	/* Set the physical disk path to store the XML file containing the data elements. */
	public abstract boolean SetDatabaseFilePath(char FilePath,
											 char FileName);
	/* Maximum disk file size allowed for this database. */
	public abstract double MaxSizeAllowed();
	/* Alternate database file path, will be used if the primary database path does not exists or the max size has occured.  */
	public abstract boolean AlternateDatabaseFilePath(char FilePath,
												   char FileName);
	/* Sets the path of XMLMetadata file, which contains the XML database meta-data for reference. */
	public abstract boolean SetMetaDataFileName(char FilePath,
											 char FileName);
	/* Allows to use XQuery for querying the XML database. */
	public abstract XMLDocumentInstance FireXQuery(XMLDocumentInstance XQueryStream);
	/* Appends or inserts the records in the XML database. The XML string passed as parameter specifies the table node and field node names. */
	public abstract boolean AppendRecords(XMLDocumentInstance XMLRecord);
	/* Edit XML records. The records format is specified in XML format. */
	public abstract boolean EditRecords(XMLDocumentInstance XMLRecords);
	/* Delete XML records. The records format is specified in XML format. */
	public abstract boolean DeleteRecords(XMLDocumentInstance XMLRecords,
									   double SecurityKey);
	/* Create a new table-field like schema. */
	public abstract boolean CreateNewSchema(XMLDocumentInstance TableSchema);
	/* Set security and authentication details for the current database.  */
	public abstract boolean SetAccessDetails(XMLDocumentInstance AccessScheme);

}
/* END CLASS DEFINITION XMLDataManager */
